// (function(){
	/*----------MODEL--------------*/
	var $audio_element = $("audio"),
		audio_element = $audio_element.get(0),
		$message_log = $("ol");
	/*----------VIEW---------------*/
	function addSoundFileToAudioElement(){
		var html_str = '';
		html_str += '<source src="beep.ogg" type="audio/ogg" />';
		html_str += '<source src="beep.mp4" type="audio/mp4" />';
		$(html_str).appendTo($audio_element);
		$audio_element.attr("controls", "");
	}
	function appendToMessageLog(msg_str){
		var html_str = '';
		html_str += '<li>' + msg_str + '</li>';
		$(html_str).appendTo($message_log);
	}
	/*----------CONTROLLER---------*/
	function errorHandler(e){
		appendToMessageLog("can't play " + e.target.type);
	}
	function genericHandler(e){
		if(e.type === "canplaythrough"){
			playTheSound();
		}
		appendToMessageLog(e.type);
	}
	function playTheSound(){
		audio_element.play();
	}
	function wireUpEventHandlers(){
		$audio_element.children().on("error", errorHandler);
		$audio_element.on("seeked seeking canplaythrough loadstart progress loadedmetadata durationchange emptied playing timeupdate suspend waiting", genericHandler);
	}
	(function(){
		addSoundFileToAudioElement();
		wireUpEventHandlers();
	})();
// })();